hdu 1595 find the longest of the shortest (Dijkstra)

find the longest of the shortest

Time Limit: 1000/5000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3347 Accepted Submission(s): 1254

Problem Description
Marica is very angry with Mirko because he found a new girlfriend and she seeks revenge.Since she doesn’t live in the same city, she started preparing for the long journey.We know for every road how many minutes it takes to come from one city to another.
Mirko overheard in the car that one of the roads is under repairs, and that it is blocked, but didn’t konw exactly which road. It is possible to come from Marica’s city to Mirko’s no matter which road is closed.
Marica will travel only by non-blocked roads, and she will travel by shortest route. Mirko wants to know how long will it take for her to get to his city in the worst case, so that he could make sure that his girlfriend is out of town for long enough.Write a program that helps Mirko in finding out what is the longest time in minutes it could take for Marica to come by shortest route by non-blocked roads to his city.

Input
Each case there are two numbers in the first row, N and M, separated by a single space, the number of towns,and the number of roads between the towns. 1 ≤ N ≤ 1000, 1 ≤ M ≤ N*(N-1)/2. The cities are markedwith numbers from 1 to N, Mirko is located in city 1, and Marica in city N.
In the next M lines are three numbers A, B and V, separated by commas. 1 ≤ A,B ≤ N, 1 ≤ V ≤ 1000.Those numbers mean that there is a two-way road between cities A and B, and that it is crossable in V minutes.

Output
In the first line of the output file write the maximum time in minutes, it could take Marica to come to Mirko.

Sample Input
5 6
1 2 4
1 3 3
2 3 1
2 4 4
2 5 7
4 5 1

6 7
1 2 1
2 3 4
3 4 4
4 6 4
1 5 5
2 5 2
5 6 5

5 7
1 2 8
1 4 10
2 3 9
2 4 10
2 5 1
3 4 7
3 5 10

Sample Output
11
13
27
题意:1-n代表有n个城市,一个人想从1城市到达n城市,但1-n城市正在修路,某些路不能走需要绕道行驶这就会花费他很多时间,求出最坏情况下从1城市到n城市的时间,注意:并不是求1-n城市的最长路径。
解题思路:首先求出在所有路都没有坏的情况 下从1城市到n城市的时间,再枚举从1城市到n城市的所有路径为坏路的情况,求出所花费时间最长的即可。

#include <bits/stdc++.h>
#define INF 0x3f3f3f3f

using namespace std;
int Map[1005][1005],dis[1005],n,m,pre[1005];
void dijkstra(int s,int flag)///求最短路径,若发flag=1表示所有路都是好的否则表示有坏路,
{
    int vis[1005],Mindist,k;
    memset(dis,INF,sizeof(dis));
    memset(vis,0,sizeof(vis));
    dis[s] = 0;
    for(int i = 1; i <= n; i ++){
        Mindist = INF;
        for(int j = 1; j <= n; j ++)
        if(vis[j] == 0 && Mindist > dis[j]){
            Mindist = dis[j];
            k = j;
        }
        vis[k] = 1;
        for(int j = 1; j <= n; j++){//
            if(vis[j] == 0 &&dis[j] > Map[k][j]+Mindist){
                dis[j] = Map[k][j]+Mindist;
                if(flag)//在所有路均为好路的情况下记录每条路的前驱节点
                    pre[j] = k;
            }
        }
    }
    //cout<<dis[n]<<endl;
}
int main()
{
    while(cin>>n>>m){
        int a,b,v;
        memset(Map,INF,sizeof(Map));
        for(int i=0;i<m;i++){
            scanf("%d %d %d",&a,&b,&v);
            Map[a][b] = min(Map[a][b],v);
            Map[b][a] = Map[a][b];
        }
        memset(pre,0,sizeof(pre));
        dijkstra(1,1);
        int ans = dis[n];
        for(int i = n; i != 1; i = pre[i]){///枚举所有可能,求出所用时间最长的
            int tmp = Map[i][pre[i]];
            Map[i][pre[i]] = Map[pre[i]][i] = INF;
            dijkstra(1,0);
            ans = max(ans,dis[n]);
            Map[i][pre[i]] = Map[pre[i]][i] = tmp;
        }
        cout<<ans<<endl;
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值